Index: drivers/filesystems/btrfs/balance.c
===================================================================
--- drivers/filesystems/btrfs/balance.c	(révision 74430)
+++ drivers/filesystems/btrfs/balance.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -17,6 +17,7 @@
 
 #include "btrfs_drv.h"
 #include "btrfsioctl.h"
+#include <ntddstor.h>
 
 typedef struct {
     UINT64 address;
@@ -64,10 +65,12 @@
     LIST_ENTRY list_entry;
 } data_reloc_ref;
 
-extern LIST_ENTRY volumes;
-extern ERESOURCE volumes_lock;
+#ifndef _MSC_VER // not in mingw yet
+#define DEVICE_DSM_FLAG_TRIM_NOT_FS_ALLOCATED 0x80000000
+#endif
 
 static NTSTATUS add_metadata_reloc(device_extension* Vcb, LIST_ENTRY* items, traverse_ptr* tp, BOOL skinny, metadata_reloc** mr2, chunk* c, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
     metadata_reloc* mr;
     EXTENT_ITEM* ei;
     UINT16 len;
@@ -86,7 +89,12 @@
     mr->system = FALSE;
     InitializeListHead(&mr->refs);
     
-    delete_tree_item(Vcb, tp, rollback);
+    Status = delete_tree_item(Vcb, tp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("delete_tree_item returned %08x\n", Status);
+        ExFreePool(mr);
+        return Status;
+    }
     
     if (!c)
         c = get_chunk_from_address(Vcb, tp->item->key.obj_id);
@@ -94,7 +102,7 @@
     if (c) {
         ExAcquireResourceExclusiveLite(&c->lock, TRUE);
         
-        decrease_chunk_usage(c, Vcb->superblock.node_size);
+        c->used -= Vcb->superblock.node_size;
         
         space_list_add(Vcb, c, TRUE, tp->item->key.obj_id, Vcb->superblock.node_size, rollback);
         
@@ -176,7 +184,11 @@
                     ref->top = FALSE;
                     InsertTailList(&mr->refs, &ref->list_entry);
                     
-                    delete_tree_item(Vcb, &tp2, rollback);
+                    Status = delete_tree_item(Vcb, &tp2);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
                 } else if (tp2.item->key.obj_type == TYPE_SHARED_BLOCK_REF && tp2.item->size >= sizeof(SHARED_BLOCK_REF)) {
                     metadata_reloc_ref* ref = ExAllocatePoolWithTag(PagedPool, sizeof(metadata_reloc_ref), ALLOC_TAG);
                     if (!ref) {
@@ -190,7 +202,11 @@
                     ref->top = FALSE;
                     InsertTailList(&mr->refs, &ref->list_entry);
                     
-                    delete_tree_item(Vcb, &tp2, rollback);
+                    Status = delete_tree_item(Vcb, &tp2);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
                 }
             } else
                 break;
@@ -258,7 +274,8 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS add_metadata_reloc_extent_item(device_extension* Vcb, metadata_reloc* mr, LIST_ENTRY* rollback) {
+static NTSTATUS add_metadata_reloc_extent_item(device_extension* Vcb, metadata_reloc* mr) {
+    NTSTATUS Status;
     LIST_ENTRY* le;
     UINT64 rc = 0;
     UINT16 inline_len;
@@ -341,16 +358,14 @@
         le = le->Flink;
     }
     
-    if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA) {
-        if (!insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_METADATA_ITEM, mr->data->level, ei, inline_len, NULL, NULL, rollback)) {
-            ERR("insert_tree_item failed\n");
-            return STATUS_INTERNAL_ERROR;
-        }
-    } else {
-        if (!insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_EXTENT_ITEM, Vcb->superblock.node_size, ei, inline_len, NULL, NULL, rollback)) {
-            ERR("insert_tree_item failed\n");
-            return STATUS_INTERNAL_ERROR;
-        }
+    if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA)
+        Status = insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_METADATA_ITEM, mr->data->level, ei, inline_len, NULL, NULL);
+    else
+        Status = insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_EXTENT_ITEM, Vcb->superblock.node_size, ei, inline_len, NULL, NULL);
+    
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
+        return Status;
     }
     
     if (!all_inline) {
@@ -370,9 +385,10 @@
                 
                 tbr->offset = ref->tbr.offset;
                 
-                if (!insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_TREE_BLOCK_REF, tbr->offset, tbr, sizeof(TREE_BLOCK_REF), NULL, NULL, rollback)) {
-                    ERR("insert_tree_item failed\n");
-                    return STATUS_INTERNAL_ERROR;
+                Status = insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_TREE_BLOCK_REF, tbr->offset, tbr, sizeof(TREE_BLOCK_REF), NULL, NULL);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
+                    return Status;
                 }
             } else if (ref->type == TYPE_SHARED_BLOCK_REF) {
                 SHARED_BLOCK_REF* sbr;
@@ -385,9 +401,10 @@
                 
                 sbr->offset = ref->parent->new_address;
                 
-                if (!insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_SHARED_BLOCK_REF, sbr->offset, sbr, sizeof(SHARED_BLOCK_REF), NULL, NULL, rollback)) {
-                    ERR("insert_tree_item failed\n");
-                    return STATUS_INTERNAL_ERROR;
+                Status = insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_SHARED_BLOCK_REF, sbr->offset, sbr, sizeof(SHARED_BLOCK_REF), NULL, NULL);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
+                    return Status;
                 }
             }
             
@@ -409,8 +426,7 @@
                     
                     sbr.offset = mr->new_address;
                     
-                    Status = increase_extent_refcount(Vcb, in[i].address, Vcb->superblock.node_size, TYPE_SHARED_BLOCK_REF, &sbr, NULL, 0,
-                                                      NULL, rollback);
+                    Status = increase_extent_refcount(Vcb, in[i].address, Vcb->superblock.node_size, TYPE_SHARED_BLOCK_REF, &sbr, NULL, 0, NULL);
                     if (!NT_SUCCESS(Status)) {
                         ERR("increase_extent_refcount returned %08x\n", Status);
                         return Status;
@@ -419,7 +435,7 @@
                     sbr.offset = mr->address;
                     
                     Status = decrease_extent_refcount(Vcb, in[i].address, Vcb->superblock.node_size, TYPE_SHARED_BLOCK_REF, &sbr, NULL, 0,
-                                                      sbr.offset, FALSE, NULL, rollback);
+                                                      sbr.offset, FALSE, NULL);
                     if (!NT_SUCCESS(Status)) {
                         ERR("decrease_extent_refcount returned %08x\n", Status);
                         return Status;
@@ -448,8 +464,7 @@
                                 sdr.offset = mr->new_address;
                                 sdr.count = sdrrc;
                                 
-                                Status = increase_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_SHARED_DATA_REF, &sdr, NULL, 0,
-                                                                  NULL, rollback);
+                                Status = increase_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_SHARED_DATA_REF, &sdr, NULL, 0, NULL);
                                 if (!NT_SUCCESS(Status)) {
                                     ERR("increase_extent_refcount returned %08x\n", Status);
                                     return Status;
@@ -458,7 +473,7 @@
                                 sdr.offset = mr->address;
                                 
                                 Status = decrease_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_SHARED_DATA_REF, &sdr, NULL, 0,
-                                                                  sdr.offset, FALSE, NULL, rollback);
+                                                                  sdr.offset, FALSE, NULL);
                                 if (!NT_SUCCESS(Status)) {
                                     ERR("decrease_extent_refcount returned %08x\n", Status);
                                     return Status;
@@ -546,7 +561,7 @@
         }
         
         Status = read_data(Vcb, mr->address, Vcb->superblock.node_size, NULL, TRUE, (UINT8*)mr->data,
-                           c && mr->address >= c->offset && mr->address < c->offset + c->chunk_item->size ? c : NULL, &pc, NULL, FALSE);
+                           c && mr->address >= c->offset && mr->address < c->offset + c->chunk_item->size ? c : NULL, &pc, NULL, 0, FALSE, 0);
         if (!NT_SUCCESS(Status)) {
             ERR("read_data returned %08x\n", Status);
             return Status;
@@ -705,7 +720,7 @@
                     ExAcquireResourceExclusiveLite(&newchunk->lock, TRUE);
                     
                     if (newchunk->chunk_item->type == flags && find_metadata_address_in_chunk(Vcb, newchunk, &mr->new_address)) {
-                        increase_chunk_usage(newchunk, Vcb->superblock.node_size);
+                        newchunk->used += Vcb->superblock.node_size;
                         space_list_subtract(Vcb, newchunk, FALSE, mr->new_address, Vcb->superblock.node_size, rollback);
                         done = TRUE;
                     }
@@ -725,7 +740,7 @@
                             
                             if ((c2->chunk_item->size - c2->used) >= Vcb->superblock.node_size) {
                                 if (find_metadata_address_in_chunk(Vcb, c2, &mr->new_address)) {
-                                    increase_chunk_usage(c2, Vcb->superblock.node_size);
+                                    c2->used += Vcb->superblock.node_size;
                                     space_list_subtract(Vcb, c2, FALSE, mr->new_address, Vcb->superblock.node_size, rollback);
                                     ExReleaseResourceLite(&c2->lock);
                                     newchunk = c2;
@@ -759,7 +774,7 @@
                             Status = STATUS_DISK_FULL;
                             goto end;
                         } else {
-                            increase_chunk_usage(newchunk, Vcb->superblock.node_size);
+                            newchunk->used += Vcb->superblock.node_size;
                             space_list_subtract(Vcb, newchunk, FALSE, mr->new_address, Vcb->superblock.node_size, rollback);
                         }
                         
@@ -854,11 +869,15 @@
                                 
                                 RtlCopyMemory(ri, &r->root_item, sizeof(ROOT_ITEM));
                                 
-                                delete_tree_item(Vcb, &tp, rollback);
+                                Status = delete_tree_item(Vcb, &tp);
+                                if (!NT_SUCCESS(Status)) {
+                                    ERR("delete_tree_item returned %08x\n", Status);
+                                    goto end;
+                                }
                                 
-                                if (!insert_tree_item(Vcb, Vcb->root_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, ri, sizeof(ROOT_ITEM), NULL, NULL, rollback)) {
-                                    ERR("insert_tree_item failed\n");
-                                    Status = STATUS_INTERNAL_ERROR;
+                                Status = insert_tree_item(Vcb, Vcb->root_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, ri, sizeof(ROOT_ITEM), NULL, NULL);
+                                if (!NT_SUCCESS(Status)) {
+                                    ERR("insert_tree_item returned %08x\n", Status);
                                     goto end;
                                 }
                             }
@@ -1021,7 +1040,7 @@
     while (le != items) {
         metadata_reloc* mr = CONTAINING_RECORD(le, metadata_reloc, list_entry);
         
-        Status = add_metadata_reloc_extent_item(Vcb, mr, rollback);
+        Status = add_metadata_reloc_extent_item(Vcb, mr);
         if (!NT_SUCCESS(Status)) {
             ERR("add_metadata_reloc_extent_item returned %08x\n", Status);
             goto end;
@@ -1132,7 +1151,7 @@
     
 end:
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
     
@@ -1154,6 +1173,7 @@
 }
 
 static NTSTATUS add_data_reloc(device_extension* Vcb, LIST_ENTRY* items, LIST_ENTRY* metadata_items, traverse_ptr* tp, chunk* c, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
     data_reloc* dr;
     EXTENT_ITEM* ei;
     UINT16 len;
@@ -1171,7 +1191,11 @@
     dr->ei = (EXTENT_ITEM*)tp->item->data;
     InitializeListHead(&dr->refs);
     
-    delete_tree_item(Vcb, tp, rollback);
+    Status = delete_tree_item(Vcb, tp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("delete_tree_item returned %08x\n", Status);
+        return Status;
+    }
     
     if (!c)
         c = get_chunk_from_address(Vcb, tp->item->key.obj_id);
@@ -1179,7 +1203,7 @@
     if (c) {
         ExAcquireResourceExclusiveLite(&c->lock, TRUE);
         
-        decrease_chunk_usage(c, tp->item->key.offset);
+        c->used -= tp->item->key.offset;
         
         space_list_add(Vcb, c, TRUE, tp->item->key.obj_id, tp->item->key.offset, rollback);
         
@@ -1366,7 +1390,11 @@
                     ref->parent = mr;
                     InsertTailList(&dr->refs, &ref->list_entry);
                     
-                    delete_tree_item(Vcb, &tp2, rollback);
+                    Status = delete_tree_item(Vcb, &tp2);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
                 } else if (tp2.item->key.obj_type == TYPE_SHARED_DATA_REF && tp2.item->size >= sizeof(SHARED_DATA_REF)) {
                     data_reloc_ref* ref = ExAllocatePoolWithTag(PagedPool, sizeof(data_reloc_ref), ALLOC_TAG);
                     if (!ref) {
@@ -1387,7 +1415,11 @@
                     ref->parent = mr;
                     InsertTailList(&dr->refs, &ref->list_entry);
                     
-                    delete_tree_item(Vcb, &tp2, rollback);
+                    Status = delete_tree_item(Vcb, &tp2);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
                 }
             } else
                 break;
@@ -1399,7 +1431,8 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS add_data_reloc_extent_item(device_extension* Vcb, data_reloc* dr, LIST_ENTRY* rollback) {
+static NTSTATUS add_data_reloc_extent_item(device_extension* Vcb, data_reloc* dr) {
+    NTSTATUS Status;
     LIST_ENTRY* le;
     UINT64 rc = 0;
     UINT16 inline_len;
@@ -1472,9 +1505,10 @@
         le = le->Flink;
     }
     
-    if (!insert_tree_item(Vcb, Vcb->extent_root, dr->new_address, TYPE_EXTENT_ITEM, dr->size, ei, inline_len, NULL, NULL, rollback)) {
-        ERR("insert_tree_item failed\n");
-        return STATUS_INTERNAL_ERROR;
+    Status = insert_tree_item(Vcb, Vcb->extent_root, dr->new_address, TYPE_EXTENT_ITEM, dr->size, ei, inline_len, NULL, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
+        return Status;
     }
     
     if (!all_inline) {
@@ -1497,9 +1531,10 @@
                 
                 off = get_extent_data_ref_hash2(ref->edr.root, ref->edr.objid, ref->edr.offset);
                 
-                if (!insert_tree_item(Vcb, Vcb->extent_root, dr->new_address, TYPE_EXTENT_DATA_REF, off, edr, sizeof(EXTENT_DATA_REF), NULL, NULL, rollback)) {
-                    ERR("insert_tree_item failed\n");
-                    return STATUS_INTERNAL_ERROR;
+                Status = insert_tree_item(Vcb, Vcb->extent_root, dr->new_address, TYPE_EXTENT_DATA_REF, off, edr, sizeof(EXTENT_DATA_REF), NULL, NULL);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
+                    return Status;
                 }
             } else if (ref->type == TYPE_SHARED_DATA_REF) {
                 SHARED_DATA_REF* sdr;
@@ -1513,9 +1548,10 @@
                 sdr->offset = ref->parent->new_address;
                 sdr->count = ref->sdr.count;
                 
-                if (!insert_tree_item(Vcb, Vcb->extent_root, dr->new_address, TYPE_SHARED_DATA_REF, sdr->offset, sdr, sizeof(SHARED_DATA_REF), NULL, NULL, rollback)) {
-                    ERR("insert_tree_item failed\n");
-                    return STATUS_INTERNAL_ERROR;
+                Status = insert_tree_item(Vcb, Vcb->extent_root, dr->new_address, TYPE_SHARED_DATA_REF, sdr->offset, sdr, sizeof(SHARED_DATA_REF), NULL, NULL);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
+                    return Status;
                 }
             }
             
@@ -1618,7 +1654,7 @@
             ExAcquireResourceExclusiveLite(&newchunk->lock, TRUE);
             
             if (find_data_address_in_chunk(Vcb, newchunk, dr->size, &dr->new_address)) {
-                increase_chunk_usage(newchunk, dr->size);
+                newchunk->used += dr->size;
                 space_list_subtract(Vcb, newchunk, FALSE, dr->new_address, dr->size, &rollback);
                 done = TRUE;
             }
@@ -1638,7 +1674,7 @@
                     
                     if ((c2->chunk_item->size - c2->used) >= dr->size) {
                         if (find_data_address_in_chunk(Vcb, c2, dr->size, &dr->new_address)) {
-                            increase_chunk_usage(c2, dr->size);
+                            c2->used += dr->size;
                             space_list_subtract(Vcb, c2, FALSE, dr->new_address, dr->size, &rollback);
                             ExReleaseResourceLite(&c2->lock);
                             newchunk = c2;
@@ -1672,7 +1708,7 @@
                     Status = STATUS_DISK_FULL;
                     goto end;
                 } else {
-                    increase_chunk_usage(newchunk, dr->size);
+                    newchunk->used += dr->size;
                     space_list_subtract(Vcb, newchunk, FALSE, dr->new_address, dr->size, &rollback);
                 }
                 
@@ -1694,8 +1730,8 @@
         Status = load_csum(Vcb, csum, dr->address, dr->size / Vcb->superblock.sector_size, NULL);
 
         if (NT_SUCCESS(Status)) {
-            add_checksum_entry(Vcb, dr->new_address, dr->size / Vcb->superblock.sector_size, csum, NULL, &rollback);
-            add_checksum_entry(Vcb, dr->address, dr->size / Vcb->superblock.sector_size, NULL, NULL, &rollback);
+            add_checksum_entry(Vcb, dr->new_address, dr->size / Vcb->superblock.sector_size, csum, NULL);
+            add_checksum_entry(Vcb, dr->address, dr->size / Vcb->superblock.sector_size, NULL, NULL);
         }
 
         ExFreePool(csum);
@@ -1705,13 +1741,13 @@
         while (off < dr->size) {
             ULONG ds = min(dr->size - off, 0x100000);
             
-            Status = read_data(Vcb, dr->address + off, ds, NULL, FALSE, data, c, NULL, NULL, FALSE);
+            Status = read_data(Vcb, dr->address + off, ds, NULL, FALSE, data, c, NULL, NULL, 0, FALSE, 0);
             if (!NT_SUCCESS(Status)) {
                 ERR("read_data returned %08x\n", Status);
                 goto end;
             }
             
-            Status = write_data_complete(Vcb, dr->new_address + off, data, ds, NULL, newchunk);
+            Status = write_data_complete(Vcb, dr->new_address + off, data, ds, NULL, newchunk, FALSE, 0);
             if (!NT_SUCCESS(Status)) {
                 ERR("write_data_complete returned %08x\n", Status);
                 goto end;
@@ -1736,7 +1772,7 @@
     while (le != &items) {
         data_reloc* dr = CONTAINING_RECORD(le, data_reloc, list_entry);
         
-        Status = add_data_reloc_extent_item(Vcb, dr, &rollback);
+        Status = add_data_reloc_extent_item(Vcb, dr);
         if (!NT_SUCCESS(Status)) {
             ERR("add_data_reloc_extent_item returned %08x\n", Status);
             goto end;
@@ -1786,8 +1822,8 @@
             extent* ext = CONTAINING_RECORD(le2, extent, list_entry);
             
             if (!ext->ignore) {
-                if (ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC) {
-                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
+                if (ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC) {
+                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
                     
                     if (ed2->size > 0 && ed2->address >= c->offset && ed2->address < c->offset + c->chunk_item->size) {
                         LIST_ENTRY* le3 = items.Flink;
@@ -1821,7 +1857,7 @@
     
 end:
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
     
@@ -2027,14 +2063,11 @@
 }
 
 static NTSTATUS add_balance_item(device_extension* Vcb) {
-    LIST_ENTRY rollback;
     KEY searchkey;
     traverse_ptr tp;
     NTSTATUS Status;
     BALANCE_ITEM* bi;
     
-    InitializeListHead(&rollback);
-    
     searchkey.obj_id = BALANCE_ITEM_ID;
     searchkey.obj_type = TYPE_TEMP_ITEM;
     searchkey.offset = 0;
@@ -2047,8 +2080,13 @@
         goto end;
     }
     
-    if (!keycmp(tp.item->key, searchkey))
-        delete_tree_item(Vcb, &tp, &rollback);
+    if (!keycmp(tp.item->key, searchkey)) {
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            goto end;
+        }
+    }
     
     bi = ExAllocatePoolWithTag(PagedPool, sizeof(BALANCE_ITEM), ALLOC_TAG);
     if (!bi) {
@@ -2074,9 +2112,9 @@
         copy_balance_args(&Vcb->balance.opts[BALANCE_OPTS_SYSTEM], &bi->system);
     }
     
-    if (!insert_tree_item(Vcb, Vcb->root_root, BALANCE_ITEM_ID, TYPE_TEMP_ITEM, 0, bi, sizeof(BALANCE_ITEM), NULL, NULL, &rollback)) {
-        ERR("insert_tree_item failed\n");
-        Status = STATUS_INTERNAL_ERROR;
+    Status = insert_tree_item(Vcb, Vcb->root_root, BALANCE_ITEM_ID, TYPE_TEMP_ITEM, 0, bi, sizeof(BALANCE_ITEM), NULL, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         goto end;
     }
     
@@ -2084,13 +2122,13 @@
     
 end:
     if (NT_SUCCESS(Status)) {
-        do_write(Vcb, NULL, &rollback);
-        free_trees(Vcb);
-        
-        clear_rollback(Vcb, &rollback);
-    } else
-        do_rollback(Vcb, &rollback);
+        Status = do_write(Vcb, NULL);
+        if (!NT_SUCCESS(Status))
+            ERR("do_write returned %08x\n", Status);
+    }
     
+    free_trees(Vcb);
+    
     ExReleaseResourceLite(&Vcb->tree_lock);
     
     return Status;
@@ -2097,13 +2135,10 @@
 }
 
 static NTSTATUS remove_balance_item(device_extension* Vcb) {
-    LIST_ENTRY rollback;
     KEY searchkey;
     traverse_ptr tp;
     NTSTATUS Status;
     
-    InitializeListHead(&rollback);
-    
     searchkey.obj_id = BALANCE_ITEM_ID;
     searchkey.obj_type = TYPE_TEMP_ITEM;
     searchkey.offset = 0;
@@ -2117,20 +2152,24 @@
     }
     
     if (!keycmp(tp.item->key, searchkey)) {
-        delete_tree_item(Vcb, &tp, &rollback);
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            goto end;
+        }
         
-        do_write(Vcb, NULL, &rollback);
+        Status = do_write(Vcb, NULL);
+        if (!NT_SUCCESS(Status)) {
+            ERR("do_write returned %08x\n", Status);
+            goto end;
+        }
+        
         free_trees(Vcb);
     }
 
     Status = STATUS_SUCCESS;
     
-end:
-    if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
-    else
-        do_rollback(Vcb, &rollback);
-    
+end:   
     ExReleaseResourceLite(&Vcb->tree_lock);
     
     return Status;
@@ -2214,7 +2253,7 @@
     
     RtlZeroMemory(sb, sizeof(superblock));
     
-    while (superblock_addrs[i] > 0 && dev->length >= superblock_addrs[i] + sizeof(superblock)) {
+    while (superblock_addrs[i] > 0 && dev->devitem.num_bytes >= superblock_addrs[i] + sizeof(superblock)) {
         Status = write_data_phys(dev->devobj, superblock_addrs[i], sb, sizeof(superblock));
         
         if (!NT_SUCCESS(Status)) {
@@ -2230,174 +2269,25 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS replace_mount_dev(device_extension* Vcb, device* dev, PDEVICE_OBJECT mountmgr, BOOL part0) {
-    NTSTATUS Status;
-    MOUNTDEV_NAME mdn, *mdn2 = NULL, *mdn3 = NULL;
-    ULONG mdnsize, mmpsize;
-    MOUNTMGR_MOUNT_POINT* mmp = NULL;
-    MOUNTMGR_MOUNT_POINTS mmps, *mmps2 = NULL;
-    ULONG i;
-    UNICODE_STRING us;
-
-    // get old device name
-    
-    Status = dev_ioctl(dev->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &mdn, sizeof(MOUNTDEV_NAME), TRUE, NULL);
-    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
-        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
-        return Status;
-    }
-    
-    mdnsize = offsetof(MOUNTDEV_NAME, Name[0]) + mdn.NameLength;
-    
-    mdn2 = ExAllocatePoolWithTag(PagedPool, mdnsize, ALLOC_TAG);
-    if (!mdn2) {
-        ERR("out of memory\n");
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    Status = dev_ioctl(dev->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, mdn2, mdnsize, TRUE, NULL);
-    if (!NT_SUCCESS(Status)) {
-        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
-        goto end;
-    }
-    
-    // get new device name
-    
-    Status = dev_ioctl(first_device(Vcb)->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &mdn, sizeof(MOUNTDEV_NAME), TRUE, NULL);
-    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
-        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
-        goto end2;
-    }
-    
-    mdnsize = offsetof(MOUNTDEV_NAME, Name[0]) + mdn.NameLength;
-    
-    mdn3 = ExAllocatePoolWithTag(PagedPool, mdnsize, ALLOC_TAG);
-    if (!mdn3) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end2;
-    }
-    
-    Status = dev_ioctl(first_device(Vcb)->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, mdn3, mdnsize, TRUE, NULL);
-    if (!NT_SUCCESS(Status)) {
-        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
-        goto end2;
-    }
-    
-    // query and delete existing mount points
-    
-    mmpsize = sizeof(MOUNTMGR_MOUNT_POINT) + mdn2->NameLength;
-    
-    mmp = ExAllocatePoolWithTag(PagedPool, mmpsize, ALLOC_TAG);
-    if (!mmp) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end2;
-    }
-    
-    RtlZeroMemory(mmp, sizeof(MOUNTMGR_MOUNT_POINT));
-    mmp->DeviceNameOffset = sizeof(MOUNTMGR_MOUNT_POINT);
-    mmp->DeviceNameLength = mdn2->NameLength;
-    RtlCopyMemory(&mmp[1], mdn2->Name, mdn2->NameLength);
-    
-    Status = dev_ioctl(mountmgr, IOCTL_MOUNTMGR_QUERY_POINTS, mmp, mmpsize, &mmps, mmpsize, TRUE, NULL);
-    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
-        ERR("IOCTL_MOUNTMGR_QUERY_POINTS returned %08x\n", Status);
-        goto end2;
-    }
-    
-    mmps2 = ExAllocatePoolWithTag(PagedPool, mmps.Size, ALLOC_TAG);
-    if (!mmps2) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end2;
-    }
-    
-    Status = dev_ioctl(mountmgr, IOCTL_MOUNTMGR_DELETE_POINTS, mmp, mmpsize, mmps2, mmps.Size, TRUE, NULL);
-    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
-        ERR("IOCTL_MOUNTMGR_DELETE_POINTS returned %08x\n", Status);
-        goto end2;
-    }
-    
-    // re-create mount points
-    
-    for (i = 0; i < mmps2->NumberOfMountPoints; i++) {
-        if (mmps2->MountPoints[i].SymbolicLinkNameOffset != 0) {
-            ULONG mcpilen;
-            MOUNTMGR_CREATE_POINT_INPUT* mcpi;
-            
-            mcpilen = sizeof(MOUNTMGR_CREATE_POINT_INPUT) + mmps2->MountPoints[i].SymbolicLinkNameLength + mdn3->NameLength;
-            
-            mcpi = ExAllocatePoolWithTag(PagedPool, mcpilen, ALLOC_TAG);
-            if (!mcpi) {
-                ERR("out of memory\n");
-                Status = STATUS_INSUFFICIENT_RESOURCES;
-                goto end2;
-            }
-            
-            mcpi->SymbolicLinkNameOffset = sizeof(MOUNTMGR_CREATE_POINT_INPUT);
-            mcpi->SymbolicLinkNameLength = mmps2->MountPoints[i].SymbolicLinkNameLength;
-            mcpi->DeviceNameOffset = mcpi->SymbolicLinkNameOffset + mcpi->SymbolicLinkNameLength;
-            mcpi->DeviceNameLength = mdn3->NameLength;
-            
-            RtlCopyMemory((UINT8*)mcpi + mcpi->SymbolicLinkNameOffset, (UINT8*)mmps2 + mmps2->MountPoints[i].SymbolicLinkNameOffset,
-                          mcpi->SymbolicLinkNameLength);
-            RtlCopyMemory((UINT8*)mcpi + mcpi->DeviceNameOffset, mdn3->Name, mdn3->NameLength);
-
-            Status = dev_ioctl(mountmgr, IOCTL_MOUNTMGR_CREATE_POINT, mcpi, mcpilen, NULL, 0, TRUE, NULL);
-            if (!NT_SUCCESS(Status)) {
-                ERR("IOCTL_MOUNTMGR_CREATE_POINT returned %08x\n", Status);
-                ExFreePool(mcpi);
-                goto end2;
-            }
-            
-            ExFreePool(mcpi);
-        }
-    }
-    
-    Status = STATUS_SUCCESS;
-    
-end2:
-    // re-add old device back to mountmgr
-    
-    if (!part0) {
-        us.Buffer = mdn2->Name;
-        us.Length = us.MaximumLength = mdn2->NameLength;
-        
-        add_volume(mountmgr, &us);
-    }
-    
-end:
-    if (mdn2)
-        ExFreePool(mdn2);
-    
-    if (mdn3)
-        ExFreePool(mdn3);
-    
-    if (mmp)
-        ExFreePool(mmp);
-    
-    if (mmps2)
-        ExFreePool(mmps2);
-
-    return Status;
-}
-
 static NTSTATUS finish_removing_device(device_extension* Vcb, device* dev) {
     KEY searchkey;
     traverse_ptr tp;
     NTSTATUS Status;
-    LIST_ENTRY rollback, *le;
-    BOOL first_dev, part0 = FALSE;
+    LIST_ENTRY* le;
+    volume_device_extension* vde;
     
-    InitializeListHead(&rollback);
+    if (Vcb->need_write) {
+        Status = do_write(Vcb, NULL);
+        
+        if (!NT_SUCCESS(Status))
+            ERR("do_write returned %08x\n", Status);
+    } else
+        Status = STATUS_SUCCESS;
     
-    if (Vcb->need_write)
-        do_write(Vcb, NULL, &rollback);
-    
     free_trees(Vcb);
     
-    clear_rollback(Vcb, &rollback);
+    if (!NT_SUCCESS(Status))
+        return Status;
     
     // remove entry in chunk tree
 
@@ -2411,8 +2301,14 @@
         return Status;
     }
 
-    if (!keycmp(searchkey, tp.item->key))
-        delete_tree_item(Vcb, &tp, &rollback);
+    if (!keycmp(searchkey, tp.item->key)) {
+        Status = delete_tree_item(Vcb, &tp);
+        
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
+    }
     
     // remove stats entry in device tree
     
